;****************************************************************
; parayti programa,kuri ivesta ilga atuntaini skaiciu urao dvejetainiu pavidalu.(7153->111001101011)
;****************************************************************


.model small
.stack 100h                                   ;paleidziamas failas uzkraunamas postumiu-256baitais

.data                                         ;eilutes nuskaitymo buferis
 Octlenght      EQU 6 ;6 baitai Oct skaitmenims 
 OctASCII	DB Octlenght+1 dup ('$')  ; 1 baitas enteriui

helpas DB 13,10,"Programa konvertuoja 8-taines skaiciu i 2-taines pavidala.",13,10,13,10,"$"           ;Define Byte (apibreiamas baito tipo kintamasis)
msg2 DB 'Iveskite 8-taini skaiciu: ',13,10,'$'
rezultatas DB 'Rezultatas: $'
error1 DB 'KLAIDA.$'
nauja DB 13,10,'$'

.code 

start: 

MOV ax,@data            ;data kopijuojama i ax
MOV ds,ax               ;ax i ds
	
	MOV	ch, 0			
	MOV	cl, [es:0080h]	;programos paleidimo parametru simboliu skaicius rasomas ES 128-ame (80h) baite
	CMP		cx, 0					;jei paleidimo parametru nera,
	JE		Nera					;nereikia nieko tikrinti.
	MOV	bx, 0081h			;programos paleidimo parametrai rasomi segmente es pradedant 129 (arba 81h) baitu


Ieskok:	
	CMP		[es:bx], '/?'	;lauztiniuose skliaustuose netiesiogine registracija
	JMP		Yra				;jeigu radau '/?', 	

	INC  bx				;neradau '/?' siuose baituose, paslenku rodykle ir tikrinu toliau esancius parametrus
	LOOP	Ieskok			;kartoti cikla

	JMP		Nera				;jei patikrinti visi parametrai ir nerastas '/?' reikia baigti programos darba


	
Yra:
	MOV	ah, 9				;i ah irasau dosinio pertraukimo funkcijos numeri
	MOV	dx, offset helpas	;i dx irasau nuoroda i spausdinamo teksto pradzia
	INT		21h				;iskvieciu dosini pertraukima - spausdinu pranesima
	JMP		Nera

Nera:

MOV di,0                ;eilutes nuo 0 

MOV ah,09h              ;09h reiksme kelia i ah
MOv dx,offset msg2      ;msg2 isvedimas i ekrana
int 21h                 ;DOS pertraukimas

xor ax,ax      ;Pirmuoju atveju reikme bus didesne nei antruoju


reading: 

mov ah,01h
int 21h

cmp al,0Dh              ;dvieju reiksmiou palyginimas
je next                 ;jei taip-kitas

MOV OctASCII[di],al     ;simbolis perkeliamas i atminti
inc di

cmp di, Octlenght
JA klaida

CMP di, Octlenght
jl reading

next: 

MOV ah, 09h
MOV dx, offset rezultatas
INT 21h

MOV ah, 09h
mov dx,offset nauja      ;persoka i nauja eilute
int 21h

xor si, si

dec di                   ;atima enteri
MOV dx,di

xor cx,cx

skaicius:

xor ax,ax

MOV al, OctASCII [si]
sub al, 30h          ;is pirmojo operando atima antraji

cmp al,0                ;palygina ar neneigiamas
jb klaida

cmp al,9                ;palygina su skaiciumi
ja klaida

PUSH dx           ;dx turinys perdedamas i steka

cmp dx,4


je ketvirtu

toliau:

    cmp dx,3
    je treciu
    
toliau3:

    cmp dx,2
    je antru
    
toliau2:

    cmp dx,1
    je pirmu
    
toliau1: 	
	add cx,ax            ;cx sudedamas su ax
    
	cmp cx,6b5dh
	ja  klaida
    
	inc si
	pop dx          ;paima 16 bitu reiksme is steko

	dec dx          ; operandas sumazinamas vienetu
    
	cmp si,di
	jle skaicius         ;suolis jei si maziau arba lygu
    
	xor ax,ax
    xor dx,dx
    
    mov ax,cx
    
    xor cx,cx
    
    mov bx,2                  ;dalyklis
    
	jmp skaldymas         ; kai visi skaiciai sudauginti ir sudeti

klaida:
 mov dx,offset error1         ;Klaidos isvedimas
 mov ah,09h
 int 21h
 jmp pabaiga

ketvirtu:

 mov bx,2    
 shl bx,11   ;operando turinys perstumiamas i kaire per 11 bitu
 mul bx      ;sudaugina operandus
 jc klaida
 jmp pabaiga

treciu:

 mov bx,2
 shl bx,8   ;operand
 mul bx
 jc klaida
 jmp toliau3
 
antru:

 mov bx,2
 shl bx,5   ;operando turinys pastumiamas i kaire per 5 bitus
 mul bx     ; sudaugina operandus
 jc klaida
 jmp toliau2	
 
pirmu:

 mov bx,2
 shl bx,2      ;operando turinys pastumiamas i kaire per 5 bitus

 mul bx        ; sudaugina operandus
 jc klaida
 jmp toliau1
 
skaldymas:

 xor dx,dx
 div bx         ;dalina
 push dx        ;dx turinys perdedamas i steka
 inc cx
 cmp ax,0
 je isvedimas
 jmp skaldymas
 	
isvedimas:

 xor dx,dx
 pop dx      ;paima 16 bitu reiksme is steko
 add dl,30h   ;sudeda
 mov ah,02h
 int 21h
 dec cx    ;operandas sumazinamas vienetu
 
 jcxz pabaiga   ;persokti jei lygu 0
 jmp isvedimas
 
pabaiga: 

 mov ax,4c00h ;pabaiga
 int 21h

end start  
 
